
#include <math.h>
#include <stdio.h>

#include "base.h"
#include "estad.h"

double desviacion (int vec[], int tam)
{
  int i;
  double h, n, ac1, ac2, sigm;
  ac1 = 0; ac2 = 0; n = 0;
  for (i=0; i < tam; i++){
    h = vec [i] ;
    ac1 += h ;
    ac2 += h * h ;
    }
  n = tam ;
  sigm = sqrt ((ac2/n) -((ac1/n)*(ac1/n))) ;
  return sigm ;
}

double promedioD (int vec[], int tam)
{
  int i;
  int  ac;
  double  acd, tamd;
  ac = 0;
  for (i=0; i < tam; i++){
    ac += vec [i] ;
    }
  acd = ac;
  tamd = tam;
  return acd/tamd ;
}

double maximoD (int vec[], int tam)
{
  double d;
  d = maxv (vec, tam);
  return d;
}

double mediaH (int vec[], int tam)
{
  int i;
  double  ac, acx;
  ac = 0;
  acx = 0;
  for (i=0; i < tam; i++){
    ac += vec [i] ;
    acx += vec [i] * i ;
    }
  return acx/ac ;
}

int maxv (int m[], int v)
{
  int mx, i;
  mx = m[0];
  if (v == 1)
    return mx;
  for (i=1; i<v; i++)
     if (m[i] > mx) mx=m[i];
  return mx;
}

int minv (int m[], int v)
{
  int mn, i;
  mn = m[0];
  if (v == 1)
    return mn;
  for (i=1; i<v; i++)
     if (m[i] < mn) mn=m[i];
  return mn;
}

int minv3 (int m[], int c0, int c1)
{
  int mn, i;
  mn = m[c0];
  if (c0 == c1)
    return mn;
  for (i=c0+1; i<=c1; i++)
     if (m[i] < mn) mn=m[i];
  return mn;
}

int prom (int m[], int v)
{
  int ac, i;
  ac = 0;
  for (i=0; i<v; i++)
     ac += m[i] ;
  return ac / v;
}

int difprom (int m[], int v)
{
  int ac, i;
  int mit;
  mit = (v-1)/2;
  ac = 0;
  for (i=0; i<mit; i++)
     ac -= m[i] ;
  for (i=mit+1; i<v; i++)
     ac += m[i] ;
  return ac / mit;
}

int dif2prom (int m[], int v)
{
  int ac, i;
  int ter;
  ter = (v-1)/2;
  ac = 0;
  for (i=0; i<ter; i++)
     ac -= m[i] ;
  for (i=ter+1; i<ter*2; i++)
     ac += m[i] * 2 ;
  for (i=ter*2+1; i<v; i++)
     ac -= m[i] ;
  return ac / ter;
}

int posmaxv (int m[], int v)
{
  int mx, i, imx;
  imx = 0;
  mx = m[0];
  if (v == 1)
    return imx;
  for (i=1; i<v; i++)
     if (m[i] > mx){
       mx=m[i];
       imx = i;
       }
  return imx;
}

// a partir de i0
int posmaxv2 (int m[], int v, int i0)
{
  int mx, i, imx;
  imx = i0;
  mx = m[i0];
  if (v == 1)
    return imx;
  for (i=1; i<v; i++)
     if (m[i+i0] > mx){
       mx=m[i+i0];
       imx = i+i0;
       }
  return imx;
}

// entre c0 y c1
int posmaxv3 (int m[], int c0, int c1)
{
  int mx, i, imx;
  imx = c0;
  mx = m[c0];
  if (c0 == c1)
    return imx;
  for (i=c0+1; i<=c1; i++)
     if (m[i] > mx){
       mx=m[i];
       imx = i;
       }
  return imx;
}

// entre c0 y c1, medio de meseta
int posmaxv3c (int m[], int c0, int c1)
{
  int mx, i, imx;
  imx = c0;
  mx = m[c0];
  if (c0 == c1)
    return imx;
  for (i=c0+1; i<=c1; i++)
     if (m[i] > mx){
       mx=m[i];
       imx = i;
       }
  for (i=imx; i<=c1; i++)
    if (m[i] < mx){
      i-- ;
      break ;
      }
  return (imx+i) / 2 ;
}

int posminv (int m[], int v)
{
  int mn, i, imn;
  imn = 0;
  mn = m[0];
  if (v == 1)
    return imn;
  for (i=1; i<v; i++)
     if (m[i] < mn){
       mn=m[i];
       imn = i;
       }
  return imn;
}

int posminv3 (int m[], int c0, int c1)
{
  int mn, i, imn;
  imn = c0;
  mn = m[c0];
  if (c0 == c1)
    return imn;
  for (i=c0+1; i<=c1; i++)
     if (m[i] < mn){
       mn=m[i];
       imn = i;
       }
  return imn;
}

int posminv3c (int m[], int c0, int c1)
{
  int mn, i, imn;
  imn = c0;
  mn = m[c0];
  if (c0 == c1)
    return imn;
  for (i=c0+1; i<=c1; i++)
    if (m[i] < mn){
      mn=m[i];
      imn = i;
      }
  for (i=imn; i<=c1; i++)
    if (m[i] > mn){
      i-- ;
      break ;
      }
  return (imn+i) / 2 ;
}

int posMaxAbsDer2 (int m[], int tam, int *del)
{
  int i, d;
  int imax, fmax, dmax;
  int f0, f;
  imax = 1; fmax = 0; dmax = 1;
  for (d=1; d<tam/2; d++){
    for (i=d; i<tam-d; i++) {
      f0 = m[i-d] + m[i+d] -2*m[i];
      f = (f0 * f0) / (d+1) ;
      /*
      printf("d %3d i: %3i f0: %4d f %6d imax %3d dmax %3d fmax %6d\n",
	      d,    i,     f0,     f,    imax,    dmax,    fmax);
	      */
      if (fmax < f){
	imax = i;
	dmax = d;
	fmax = f;
	}
      }
    }
  *del = dmax;
  return imax;
}

// -------------------- = --------------------

// en m[]  c0..c1
// posicion hacia izquierda de pp (punto de partida)
//     de un maximo relativo en un entorno delen (delta entorno)
int posMaxEntorIzq0 (int m[], int pp, int c0, int delen, int c1)
{
  int i, j;
  int j0, j1;
  Boolean maxm;
  for (i=pp; i>=c0 ; i--) {
    j1=min(i+delen, c1);
    j0=max(c0,i-delen);
    maxm = TRUE;
    for (j=j1; (j>=j0) && maxm; j--){
      maxm = m[j] <= m[i];
      }
    if (maxm) break;
    }
  return max(i, c0);
}

int posMaxEntorIzq (int m[], int pp, int c1, int delen)
{
  return posMaxEntorIzq0 (m, pp, c1, delen, pp);
}

int posMaxEntorIzq2 (int m[], int pp, int c1, int delen)
{
  return posMaxEntorIzq0 (m, pp, c1, delen, pp+delen);
}

int posMinEntorIzq0 (int m[], int pp, int c0, int delen, int c1)
{
  int i, j;
  int j0, j1;
  Boolean minm;
  for (i=pp; i>=c0 ; i--) {
    j1=min(i+delen, c1);
    j0=max(c0,i-delen);
    minm = TRUE;
    for (j=j1; (j>=j0) && minm; j--){
      minm = m[j] >= m[i];
      }
    if (minm) break;
    }
  return max(i, c0);
}

int posMinEntorIzq (int m[], int pp, int c1, int delen)
{
  return posMinEntorIzq0 (m, pp, c1, delen, pp);
}

int posMinEntorIzq2 (int m[], int pp, int c1, int delen)
{
  return posMinEntorIzq0 (m, pp, c1, delen, pp+delen);
}

int posMaxEntorDer0 (int m[], int pp, int c1, int delen, int c0)
{
  int i, j;
  int j0, j1;
  Boolean maxm;
  for (i=pp; i<=c1 ; i++) {
    j0=max(c0,i-delen);
    j1=min(i+delen, c1);
    maxm = TRUE;
    for (j=j0; (j<=j1) && maxm; j++){
      maxm = m[j] <= m[i];
      }
    if (maxm) break;
    }
  return min(i, c1);
}

int posMaxEntorDer (int m[], int pp, int c1, int delen)
{
  return posMaxEntorDer0 (m, pp, c1, delen, pp);
}

int posMaxEntorDer2 (int m[], int pp, int c1, int delen)
{
  return posMaxEntorDer0 (m, pp, c1, delen, pp-delen);
}

int posMinEntorDer0 (int m[], int pp, int c1, int delen, int c0)
{
  int i, j;
  int j0, j1;
  Boolean minm;
  for (i=pp; i<=c1 ; i++) {
    j0=max(c0,i-delen);
    j1=min(i+delen, c1);
    // printf ("j0:%4d j1:%4d\n", j0, j1);
    minm = TRUE;
    for (j=j0; (j<=j1) && minm; j++){
      // printf ("i:%4d j:%4d,  m[i]:%4d, m[j]:%4d\n", i, j, m[i], m[j]);
      if (i != j)
        minm = m[j] > m[i];
      }
    if (minm) break;
    }
  return min(i, c1);
}

int posMinEntorDer (int m[], int pp, int c1, int delen)
{
  return posMinEntorDer0 (m, pp, c1, delen, pp);
}

int posMinEntorDer2 (int m[], int pp, int c1, int delen)
{
  return posMinEntorDer0 (m, pp, c1, delen, pp-delen);
}

/*
int posMinEntorDer (int m[], int pp, int c1, int delen)
{
  int i, j;
  int j0, j1;
  Boolean minm;
  for (i=pp; i<=c1 ; i++) {
    j0=max(pp,i-delen);
    j1=min(i+delen, c1);
    printf ("j0:%4d j1:%4d\n", j0, j1);
    minm = TRUE;
    for (j=j0; (j<=j1) && minm; j++){
      printf ("i:%4d j:%4d,  m[i]:%4d, m[j]:%4d\n", i, j, m[i], m[j]);
      minm = m[j] >= m[i];
      }
    if (minm) break;
    }
  return i;
}

int posMinEntorDer2 (int m[], int pp, int c1, int delen)
{
  int i, j;
  int j0, j1;
  Boolean minm;
  for (i=pp; i<=c1 ; i++) {
    j0=i-delen;
    j1=min(i+delen, c1);
    printf ("j0:%4d j1:%4d\n", j0, j1);
    minm = TRUE;
    for (j=j0; (j<=j1) && minm; j++){
      printf ("i:%4d j:%4d,  m[i]:%4d, m[j]:%4d\n", i, j, m[i], m[j]);
      minm = m[j] >= m[i];
      }
    if (minm) break;
    }
  return i;
}
*/

// -------------------- = --------------------

void vconstante (int *vec, int k, int tam)
{
  int i;
  for (i=0; i<tam; i++)
    vec[i] = k ;
}

void vcopia (int *vec2, int *vec, int tam)
{
  int i;
  for (i=0; i<tam; i++)
    vec2[i] = vec[i] ;
}

// -------------------- = --------------------

// acumulado de vector
void vacum (int *vec2, int *vec, int tam)
{
  int i;
  vec2 [0] = vec [0];
  for (i=1; i<tam; i++)
    vec2[i] += vec[i] ;
}

// diferencia evidente,  + - del
void vdife (int *vec2, int *vec, int tam, int del)
{
  int i;
  if (tam < 2*del) {
    printf ("vdife error\n");
    }
  for (i=0; i<del; i++)
    vec2[i] = vec[i+del] - 0;
  for (i=del; i<(tam-del); i++)
    vec2[i] = vec[i+del] - vec[i-del];
  for (i=tam-del; i<tam; i++)
    vec2[i] = vec[tam] - vec[i-del];
}

// diferencia supuesta,  + - del
void vdifs (int *vec2, int *vec, int tam, int del)
{
  int i;
  if (tam < 2*del) {
    printf ("vdife error\n");
    }
  for (i=0; i<del; i++)
    vec2[i] = (vec[i+del] - 0)*2*del/(i+del);
  for (i=del; i<(tam-del); i++)
    vec2[i] = vec[i+del] - vec[i-del];
  for (i=tam-del; i<tam; i++)
    vec2[i] = (vec[tam] - vec[i-del])*2*del/(del+tam-i);
}


// -------------------- = --------------------

int acum (int m[], int v)
{
  int ac, i;
  ac = 0;
  if (v>0)
    for (i=0; i<v; i++)
       ac += m[i] ;
  return ac ;
}

int pend (int m[], int v)
{
  return (m[v-1] - m[0])/(v-1);
}

void acuadr (int *vec2, int *vec, int tam)
{
  // double dmed, d;
  int i, med;
  med = prom (vec, tam);
  if (med != 0)
    for (i=0; i<tam; i++)
      vec2[i] = vec[i]*vec[i]/med;
  else
    /* med entre 0 y 1 */
    for (i=0; i<tam; i++)
      vec2[i] = vec[i]*vec[i];
}

Boolean posy (double *py, int m[], int y, int pi, int pf)
{
  int i;
  double dif;
  Boolean encontrado = FALSE;
  if (pi < pf) {
    for (i=pi; (i<pf) && !encontrado; i++)
      encontrado = ((m[i]-y)*(m[i+1]-y)) <= 0 ;
    if (encontrado) {
      dif = m[i+1]-m[i];
      *py = i + (y-m[i])/dif;
      }
    }
  else {
    for (i=pi; (i>pf) && !encontrado; i--)
      encontrado = ((m[i]-y)*(m[i-1]-y)) <= 0 ;
    if (encontrado) {
      dif = m[i-1]-m[i];
      *py = i - (y-m[i])/dif;
      }
    }
  return encontrado;
}

// -------------------- = --------------------

// a partir de i0
int posrmaxv2 (float m[], int v, int i0)
{
  float mx;
  int i, imx;
  imx = i0;
  mx = m[i0];
  if (v == 1)
    return imx;
  for (i=1; i<v; i++)
     if (m[i+i0] > mx){
       mx=m[i+i0];
       imx = i+i0;
       }
  return imx;
}

void imprimeVecI (int m[], int tam)
{
  int i;
  for (i=0; i<tam; i++) {
    if (i%10==0) {
      if (i==0)
        printf("%3d", i);
      else
        printf("\n%3d", i);
      }
    printf(" %5d", m[i]);
    }
  printf("\n");
}

