
#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#include "errors.h"
#include "grises.h"
#include "imag.h"
// #include "inclfont.h"
#include "inclina0.h"
#include "opcns.h"
#include "plot.h"
#include "tarea.h"

void histoHor (int *hisH, tvent vent)
{
  int x, y;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(y=0;y<ty;y++)hisH[y]=0;
  for(x=0;x<tx;x++)
    for(y=0;y<ty;y++)
      hisH[y] += (pix[y][x] & 0x0FF) ;
  for(y=0;y<ty;y++)hisH[y]/=tx;
  if (d_valori >= 10)
    printf ("ocre: histHor\n") ;
  if (d_valori >= 30)
    for(y=0;y<ty;y++)printf("histoHor, %4d %7d\n",y, hisH[y]);
}   

// .. conv[..]
void histoHor2 (int *hisH, tvent vent)
{   
  int  x, y;
  int tx, ty;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoHor2, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  for(y=0;y<ty;y++)hisH[y]=0;
  for(x=0;x<tx;x++)
    for(y=0;y<ty;y++)
      hisH[y] += conv[(pix[y][x] & 0x0FF)] ;
// for(y=0;y<ty;y++)hisH[y]/=tx;
  for(y=0;y<ty;y++){hisH[y]*=256;hisH[y]/=tx;}
  if (d_valori >= 10)
    printf ("ocre: histHor2\n") ;
  if (d_valori >= 30)
    for(y=0;y<ty;y++)printf("histoHor2, %4d %7d\n",y, hisH[y]);
}   

// .. conv[..]
// x0..x1 : pesoR,   0..tx-1 : 100-pesoR
void histoHor3 (int *hisH, tvent vent, int x0, int x1, int pesoR)
{   
  int  x, y;
  int tx, ty;
  int ac, acR;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoHor3, no valor en conv\n");
    exit (3);
    }
  if (x0 >= vent->tx) {
    printf ("ocre: error en histos.histoHor3, x0 >= vent->tx\n");
    exit (4);
    }
  if (x1 >= vent->tx) {
    printf ("ocre: error en histos.histoHor3, x1 >= vent->tx\n");
    exit (4);
    }
  if (x1 < x0) {
    printf ("ocre: error en histos.histoHor3, x1 < x0\n");
    exit (4);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  for(y=0;y<ty;y++) {
    ac = 0;
    for(x=0;x<tx;x++)
      ac += conv[(pix[y][x] & 0x0FF)] ;
    acR = 0;
    for(x=x0;x<x1;x++)
      acR += conv[(pix[y][x] & 0x0FF)] ;
    hisH[y] = ( (100-pesoR) * ac / tx +
		    pesoR * acR /(x1-x0+1) )/100;
    }
  if (d_valori >= 10)
    printf ("ocre: histHor3\n") ;
  if (d_valori >= 30)
    for(y=0;y<ty;y++)printf("histoHor3, %4d %7d\n",y, hisH[y]);
}   

void histoVer (int *hisV, tvent vent)
{
  int x, y;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=0;x<tx;x++)
      hisV[x] += (pix[y][x] & 0x0FF) ;
  for(x=0;x<tx;x++){hisV[x]*=256;hisV[x]/=ty;}
  if (d_valori >= 10)
    printf ("ocre: histVer\n") ;
  if (d_valori >= 30) {
    describeVentana (vent);
    for(x=0;x<tx;x++)printf("histoVer, %4d %7d\n",x, hisV[x]);
    }
}   

// max ...
void histoVerMax (int *hisV, tvent vent)
{
  int x, y;
  int tx, ty;
  char ** pix;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=0;x<tx;x++)
      hisV[x] = max(hisV[x],(pix[y][x] & 0x0FF)) ;
  if (d_valori >= 10)
    printf ("ocre: histVerMax\n") ;
  if (d_valori >= 30) {
    describeVentana (vent);
    for(x=0;x<tx;x++)printf("histoVerMax, %4d %7d\n",x, hisV[x]);
    }
}   

/* con m = 6  se toma el nivel de gr del sexto pixel mas claro */
void histoVerModa (int *hisV, tvent vent, int m)
{
  int x, y;
  int tx, ty;
  char ** pix;
  int gr[256];
  int g, cm;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(x=0;x<tx;x++){
    for (g=0; g<= 255; g++)
      gr[g] = 0;
    for(y=0;y<ty;y++)
      gr[(pix[y][x] & 0x0FF)] ++;
    cm = 0;
    for (g=255; g>=0; g--){
      cm += gr[g];
      if (cm >= m) break;
      }
    hisV[x] = g;
    }
  if (d_valori >= 10)
    printf ("ocre: histVerModa\n") ;
  if (d_valori >= 30) {
    describeVentana (vent);
    for(x=0;x<tx;x++)printf("histoVerModa, %4d %7d\n",x, hisV[x]);
    }
}   

/* con m = 6  se toma el nivel medio de gr del sseis pixels mas claros */
void histoVerMediaMaxs (int *hisV, tvent vent, int m)
{
  int x, y;
  int tx, ty;
  char ** pix;
  int gr[256];
  int g, cm;
  int sm;
  tx  = vent->tx ;
  ty  = vent->ty ;
  pix = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(x=0;x<tx;x++){
    for (g=0; g<= 255; g++)
      gr[g] = 0;
    for(y=0;y<ty;y++)
      gr[(pix[y][x] & 0x0FF)] ++;
    cm = 0;
    sm = 0;
    for (g=255; g>=0; g--){
      sm += g * min(gr[g], m-cm) ;
      cm += gr[g];
      if (cm >= m) break;
      }
    hisV[x] = (sm + m/2) / m;
    }
  if (d_valori >= 10)
    printf ("ocre: histVerMediaMaxs\n") ;
  if (d_valori >= 30) {
    describeVentana (vent);
    for(x=0;x<tx;x++)printf("histoVerMediaMaxs, %4d %7d\n",x, hisV[x]);
    }
}   

// .. conv[..]
void histoVer2 (int *hisV, tvent vent)
{   
  int  x, y;
  int tx, ty;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer2, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=0;x<tx;x++)
      hisV[x] += conv[(pix[y][x] & 0x0FF)] ;
//  for(x=0;x<tx;x++)hisV[x]/=ty;
  for(x=0;x<tx;x++){hisV[x]*=256;hisV[x]/=ty;}
  if (d_valori >= 10)
    printf ("ocre: histVer2\n") ;
  if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVer2, %4d %7d\n",x, hisV[x]);
}   

/* sin conversion de grises                            */
/* la inclinacion era relativa a 256                   */
/* la inclinacion es  relativa a 64k                   */
void histoVerIncl (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi;
  char ** pix;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=xp; x <= xu;x++) {
      xi = x + inclf_desvx(inc, y);
      hisV[x] += (pix[y][xi] & 0x0FF) ;
      }
  for(x=0;x<tx;x++)hisV[x]/=ty;
  // prolonga
  for(x=0;   x<xp;x++) hisV[x]=hisV[xp];
  for(x=xu+1;x<tx;x++) hisV[x]=hisV[xu];
  if (d_valori >= 10)
    printf ("ocre: histVer\n") ;
  if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVer2Incl, %4d %7d\n",x, hisV[x]);
}   

/* la inclinacion era relativa a 256                   */
/* la inclinacion es  relativa a 64k                   */
// ... hisV[x] += conv
void histoVer2Incl (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer2Incl, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=xp; x <= xu;x++) {
      xi = x + inclf_desvx(inc, y);
      hisV[x] += conv[(pix[y][xi] & 0x0FF)] ;
      }
  for(x=0;x<tx;x++)hisV[x]/=ty;
  // prolonga
  for(x=0;   x<xp;x++) hisV[x]=hisV[xp];
  for(x=xu+1;x<tx;x++) hisV[x]=hisV[xu];
  if (d_valori >= 10)
    printf ("ocre: histVer2\n") ;
  if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVer2Incl, %4d %7d\n",x, hisV[x]);
}   

/* la inclinacion era relativa a 256                   */
/* la inclinacion es  relativa a 64k                   */
/* para corte de caracteres e inclinacion de palabras */
// ... hisV[x] += conv ...,  y prolong 0 _ xp ...
void histoVer3Incl (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer3Incl, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for(x=0;x<tx;x++)hisV[x]=0;
  for(y=0;y<ty;y++)
    for(x=xp; x <= xu;x++) {
      xi = x + inclf_desvx(inc, y);
      hisV[x] += conv[(pix[y][xi] & 0x0FF)] ;
      }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisV */
  for(x=0;    x<xp-1; x++)hisV[x]=hisV[xp];
  for(x=xu+1; x<tx-1; x++)hisV[x]=hisV[xu];
  for(x=0;x<tx;x++)hisV[x]/=ty;
  if (d_valori >= 10)
    printf ("ocre: histVer3Incl\n") ;
  if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVer3Incl, %4d %7d\n",x, hisV[x]);
}   

void histoVer3InclDifAcum (int *hisV, tvent vent, int inc)
{
  int  x, y;
  int tx, ty;
  int xp, xu, xi;
  int pixant, pixac;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer3InclDifAcum, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for(x=0;x<tx;x++)hisV[x]=0;
  for(x=xp; x <= xu;x++) {
    pixant = conv[(pix[0][x] & 0x0FF)] ;
    for(y=0;y<ty;y++){
      xi = x + inclf_desvx(inc, y);
      pixac = conv[(pix[y][xi] & 0x0FF)] ;
      hisV[x] += abs(pixac - pixant) ;
      pixant = pixac;
      }
    }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisV */
  for(x=0;    x<xp-1; x++)hisV[x]=hisV[xp];
  for(x=xu+1; x<tx-1; x++)hisV[x]=hisV[xu];
  // for(x=0;x<tx;x++)hisV[x]/=ty;
  if (d_valori >= 10)
    printf ("ocre: histoVer3InclDifAcum\n") ;
  if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVer3InclDifAcum, %4d %7d\n",x, hisV[x]);
}   

// pixels oscuros consecutivos
// la inclinacion era relativa a 256
// la inclinacion es  relativa a 64k
// para inclinacion de palabras
void histoVer3InclCuad (int *hisV, tvent vent, int inc)
{   
  int  x, y;
  int tx, ty;
  int xp, xu, xi;
  char ** pix;
  // int * conv;
  int nn;
  int umbral;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVer3InclCuad, no valor en conv\n");
    exit (3);
    }
  umbral = umbralDeVent(vent, 55);
  // conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for(x=0;x<tx;x++)hisV[x]=0;
  for(x=xp; x <= xu;x++) {
    nn = 0;
    for(y=0;y<ty;y++) {
      xi = x + inclf_desvx(inc, y);
      if ((pix[y][xi] & 0x0FF) < umbral) {
	nn ++;
	hisV[x] += nn ;
	}
      else nn = 0;
      }
    }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisV */
  for(x=0;    x<xp-1; x++)hisV[x]=hisV[xp];
  for(x=xu+1; x<tx-1; x++)hisV[x]=hisV[xu];
  /*
  for(x=0;x<tx;x++)hisV[x]/=ty;
  */
  if (d_valori >= 10)
    printf ("ocre: histVer3InclCuad\n") ;
 if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVer3InclCuad, %4d %7d\n",x, hisV[x]);
}   

// ---------------------

// la inclinacion es relativa a 65536
// para detectar lineas H blancas largas
void histoHorInclLinb (int *hisH, tvent vent, int inc, int desc)
{   
  int  x, y;
  int tx, ty, txd2;
  int yp, yu, yi;
  char ** pix;
  // int * conv;
  int bb, nn;
  int umbral;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoHorInclLinb, no valor en conv\n");
    exit (3);
    }
  umbral = umbralDeVent(vent, 45);
  // conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, tx, ty, &yp, &yu);
  // printf ("dys: %4d ty: %4d yp: %4d yu: %4d imas1: %4d\n",dys, ty, yp, yu, imas1);
  for(y=0;y<ty;y++)hisH[y]=0;
  for(y=yp; y <= yu;y++) {
    bb = 0;
    nn = 0;
    for(x=0;x<tx;x++) {
      yi = y + inclf_desvx(inc, x);
      if ((pix[yi][x] & 0x0FF) > umbral) {
	bb ++;
	nn = 0;
	hisH[y] += bb ;
	}
      else {
	nn += desc ;
	bb = max(bb-nn,0) ;
	hisH[y] += bb ;
        }
      // else bb = 0;
      }
    }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisH */
  for(y=0;    y<yp; y++)hisH[y]=hisH[yp];
  for(y=yu+1; y<ty; y++)hisH[y]=hisH[yu];
  txd2 = tx / 2;
  for(y=0;    y<ty; y++)hisH[y] /= txd2;
  if (d_valori >= 10)
    printf ("ocre: histoHorInclLinb\n") ;
  if (d_valori >= 30)
    for(y=0;y<ty;y++)printf("histoHorInclLinb, %4d %7d\n",y, hisH[y]);
}   

// la inclinacion es relativa a 65536
// para detectar lineas V blancas largas
void histoVerInclLinb (int *hisV, tvent vent, int inc, int desc)
{   
  int  x, y;
  int tx, ty, tyd2;
  int xp, xu, xi;
  char ** pix;
  // int * conv;
  int bb;
  // int nn;
  int umbral;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.histoVerInclLinb, no valor en conv\n");
    exit (3);
    }
  umbral = umbralDeVent(vent, 45);
  // conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for(x=0;x<tx;x++)hisV[x]=0;
  for(x=xp; x <= xu;x++) {
    bb = 0;
    for(y=0;y<ty;y++) {
      xi = x + inclf_desvx(inc, y);
      if ((pix[y][xi] & 0x0FF) > umbral) {
	bb ++;
	hisV[x] += bb ;
	}
      else {
	bb = max(bb-desc,0) ;
	hisV[x] += bb ;
        }
      // else bb = 0;
      }
    }
  /* prolongo los valores,
   * me parece mas limpio reducir el ambito de validez de hisV */
  for(x=0;    x<xp; x++)hisV[x]=hisV[xp];
  for(x=xu+1; x<tx; x++)hisV[x]=hisV[xu];
  tyd2 = ty / 2;
  for(x=0;    x<tx; x++)hisV[x] /= tyd2;
  if (d_valori >= 10)
    printf ("ocre: histoVerInclLinb\n") ;
  if (d_valori >= 30)
    for(x=0;x<tx;x++)printf("histoVerInclLinb, %4d %7d\n",x, hisV[x]);
}   

// ---------------------

void desvTipVer2 (int *desvTipV, tvent vent, int inc)
{   
  int  x, y;
  int xp, xu, xi;
  int tx, ty;
  int ac1, ac2;
  int grisc;
  char ** pix;
  int * conv;
  if (vent->conv == 0L) {
    printf ("ocre: error en histos.desvTipVer2, no valor en conv\n");
    exit (3);
    }
  conv = vent->conv ;
  tx   = vent->tx ;
  ty   = vent->ty ;
  pix  = vent->pix ;
  pon_vprim_vult (inc, ty, tx, &xp, &xu);
  for (x=xp; x <= xu; x++){
    ac1 = 0;
    ac2 = 0;
    for(y=0;y<ty;y++){
      xi = x + inclf_desvx(inc, y);
      grisc = conv[(pix[y][xi] & 0x0FF)] ;
      ac1 += grisc ;
      ac2 += grisc * grisc ;
      }
    ac1 /= ty;
    ac2 /= ty;
    desvTipV[x] = sqrt (ac2 - (ac1 * ac1));
    }
  if (d_valori >= 10)
    printf ("ocre: histVer2\n") ;
  if (d_valori >= 30) {
    describeVentana (vent);
    for(x=0;x<tx;x++)printf("desvTipVer2, %4d %7d\n",x, desvTipV[x]);
    }
}   

void escribeHistoHorH (char *nf, int *hisH, tvent vent)
{
  int y;
  FILE * fd;
  int ty;
  ty  = vent->ty ;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeHistoHorH");
  for(y=0;y<ty;y++)
    fprintf(fd, "%4d %4d\n",hisH[y], -y);
  fclose(fd);
}

void escribeHistoVer (char *nf, int *hisV, tvent vent)
{
  int x;
  FILE * fd;
  int tx;
  tx  = vent->tx ;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeHistoVer");
  for(x=0;x<tx;x++)
    fprintf(fd, "%4d %4d\n", x, hisV[x]);
  fclose(fd);
}

void escribeNvector (char *nf, int **nvect, int nv, int tx, int sep)
{
  FILE * fd;
  int x;
  int i;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeNvector");
  for(x=0;x<tx;x++){
    fprintf(fd, "%4d", x);
    for(i=0; i<nv; i++)
      fprintf(fd, " %4d", nvect[i][x]+i*sep);
    fprintf(fd, "\n");
    }
  fclose(fd);
}

void escribModtfeHistoHor (char *nf, int *mods, int t)
{
  int y;
  FILE * fd;
  fd = fopen (nf, "w");
  compruebaFd (fd, nf, "histos.escribeModtfHistoHor");
  for(y=1;y<(t/2);y++)
    fprintf(fd, "%5d %5d\n", mods[y], -y);
  fclose(fd);
}

void presentaHistoHorH (int *nnh, int *hisH, tvent vent, char *nfd, char *nfi)
{
  escribeHistoHorH (nfd, hisH, vent);
  escribeComGnuplotSimp (nfi, nfd, "1:2");
  tareaGnuplot (nnh, nfi, "400x600");
}

void presentaHistoVer (int *nnh, int *hisV, tvent vent, char *nfd, char *nfi)
{
  escribeHistoVer (nfd, hisV, vent);
  escribeComGnuplotSimp (nfi, nfd, "1:2");
  tareaGnuplot (nnh, nfi, "600x400");
}

void presentanHistoVer (int *nnh, int **nvect, int nv, int tam,
                        int sep, char *nfd, char *nfi)
{
  escribeNvector (nfd, nvect, nv, tam, sep);
  escribeComGnuplotMult2 (nfi, nfd, nv);
  tareaGnuplot (nnh, nfi, "600x400");
}

