
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>

#include "config.h"
#include "imagio.h"
#include "misc.h"
#include "tarea.h"

void presentaFichImag (int *nnh, char *nf, int escala)
{
#ifdef XV
  char ** argv_xv;
  char  stescala[9];
#endif
#ifdef PDISPLAY
  char ** argv_display;
  char *disp;
  char envdisp[100];
#endif
  static char  * env2 [] = {"DISPLAY=:0.0", (char *)0L };
#ifdef XV
  sprintf (stescala, "%d", escala);
  listaAarray (&argv_xv, 4, "xv", "-expand", stescala, nf);
  tarea (nnh, XV, argv_xv, env2);
#endif
#ifdef PDISPLAY
  listaAarray (&argv_display, 2, "display", nf);
  if ((disp = getenv("DISPLAY")) != (char *)0L){
    strcpy  (envdisp, "DISPLAY=");
    strncat (envdisp, disp, 100);
    env2[0] = envdisp;
   }
  // printf ("envdisp: %s\n", envdisp);
  tarea (nnh, PDISPLAY, argv_display, env2);
#endif
}

void presentaVentana (int *nnh, tvent vent, char *nf, int escala)
{
  escribeVentana (vent, nf);
  presentaFichImag (nnh, nf, escala);
}

void presentaVentanayPara (tvent vent, char *nf, int escala)
{
  int  nnh;
  escribeVentana (vent, nf);
  presentaFichImag (&nnh, nf, escala);
  para ();
}

void presentaVentanayEspera (tvent vent, char *nf, int escala)
{
  int  nnh;
  escribeVentana (vent, nf);
  presentaFichImag (&nnh, nf, escala);
  espera (nnh);
}


