
#include <stdio.h>

// #include "base.h"
#include "distrib.h"
// #include "estad.h"
#include "glifos.h"
#include "inclina.h"
#include "misc.h"
#include "opcns.h"

#define K64 65536
#define K32 32768

typedef struct tealineam{
  int xi, xd, xc, bs, dfbss;
  } talineam;

Boolean alineamiento (talineam * al, tglifo glifoLinea) 
{
  tglifo glifoPrimPalabra, glifoPrimChar;
  tglifo glifoUltmPalabra, glifoUltmChar;
  tnodolglifo nlglifoUltmPalabra;
  int  alturax;
  /* falta  WHILE para buscar ultimo (primer) caracter preguntando por 'tipo' ?*/
  glifoPrimPalabra = glifoLinea       -> listaGlifos -> primero -> aglifo ;
//  describeGlifo (glifoPrimPalabra, 0);
  if ((glifoPrimPalabra->listaGlifos == 0L) ||
      (longListagl(glifoPrimPalabra->listaGlifos) == 0))
    return FALSE;
  glifoPrimChar    = glifoPrimPalabra -> listaGlifos -> primero -> aglifo ;
//  describeGlifo (glifoPrimChar, 0);
  while ((glifoPrimChar->tipo != glifCar) && (glifoPrimChar->tipo != glifArtf))
    glifoPrimChar = glifoPrimChar -> listaGlifos -> primero -> aglifo ;
  glifoLinea->linLimizq =
  (*al).xi = glifoPrimChar -> venDeGlifo -> dx ;
  //
  // glifoUltmPalabra = glifoLinea       -> listaGlifos -> ultimo -> anterior -> aglifo ;
  nlglifoUltmPalabra = glifoLinea       -> listaGlifos -> ultimo -> anterior ;
  while (nlglifoUltmPalabra->aglifo->tipo != glifCompPal) 
    nlglifoUltmPalabra = nlglifoUltmPalabra -> anterior ;
  glifoUltmPalabra = nlglifoUltmPalabra -> aglifo ;
  glifoUltmChar    = glifoUltmPalabra -> listaGlifos -> ultimo -> aglifo ;
  while ((glifoUltmChar->tipo != glifCar) && (glifoUltmChar->tipo != glifArtf))
    glifoUltmChar = glifoUltmChar -> listaGlifos -> ultimo -> aglifo ;
  glifoLinea->linLimder =
  (*al).xd = glifoUltmChar -> venDeGlifo -> dx +
             glifoUltmChar -> venDeGlifo -> tx ;
  //
  baseyalturaxDeGlifo (&(*al).bs, & alturax, glifoPrimPalabra);
  glifoLinea->linBaseEncol = (*al).bs;
  return TRUE;
}

#define MAXLINS 500
static  int n;
static  talineam als[MAXLINS];
static  int v[MAXLINS];

void escribeAlineamientos (talineam als[], int n)
{
  int i;
  for (i=0; i<n; i++)
    printf ("xizq: %4d, xder: %4d, base: %4d, difbss: %4d\n",
            als[i].xi, als[i].xd, als[i].bs, als[i].dfbss);
}

int sumaCuadsAjuste (int cg [], int na, int v[], int n)
{
  int i, j, sumcuad;
  int mindis;
  sumcuad = 0;
  for (i=0; i<n; i++){
    mindis = abs(v[i] - cg[0]);
    for (j=1; j<na; j++)
      if (abs(v[i]-cg[j]) < mindis)
	mindis = abs(v[i]-cg[j]);
    sumcuad += mindis * mindis;
    }
  return sumcuad;
}

void unAjusteIzqDer (int *na, int cg[], int *sumaCuads, int incl, int ladoAj, int v[], int n)
{
  int i;
  int ng;
  for (i=0; i<n; i++){
    switch (ladoAj) {
      case 0:
        v[i] = als[i].xi - (als[i].bs * incl + K32) / K64;
	break;
      case 1:
        v[i] = als[i].xd - (als[i].bs * incl + K32) / K64;
	break;
      }
    }
  agrupa (cg, &ng, v, n, 4);
  *sumaCuads = sumaCuadsAjuste(cg, ng, v, n) ;
  *na = ng;
}

int ajustesLinea (int ladoAj)
{
  int inc, incop0, incop;
  int incmn, incmx;
  int deltaInc ;
  int del0, del1;
  int ng, sumaCuads, ngmn, sumaCuadsmn;
  int cg[MAXLINS];
  incmn = -4096; incmx = 4096;    
  del0= (incmx - incmn) / 8;
  del1 = del0 / 2;
  ngmn = n+1 ;
  for(inc = incmn; inc <= incmx; inc+=del0) {
    unAjusteIzqDer (&ng, cg, &sumaCuads, inc, ladoAj, v, n);
    if (d_valori >= 20)
      printf ("inc: %5d, ng: %4d, sumcuadAjus: %4d\n", inc, ng, sumaCuads );
    if (d_valori == 10)
      printf (".");
    if ((ng < ngmn) || ((ng == ngmn) && (sumaCuads < sumaCuadsmn) )) {
      ngmn = ng;
      sumaCuadsmn = sumaCuads;
      incop = inc;
      }
    }
  for (deltaInc=del1; deltaInc>=1; deltaInc /=2){
    incop0 = incop;
    for (inc = incop0-deltaInc*3; inc <= incop0+deltaInc*3; inc+=(deltaInc*2)) {
      unAjusteIzqDer (&ng, cg, &sumaCuads, inc, ladoAj, v, n);
      if (d_valori >= 20)
        printf ("inc: %5d, ng: %4d, sumcuadAjus: %4d\n", inc, ng, sumaCuads );
      if (d_valori == 10)
        printf (".");
      if ((ng < ngmn) || ((ng == ngmn) && (sumaCuads < sumaCuadsmn) )) {
        ngmn = ng;
        sumaCuadsmn = sumaCuads;
        incop = inc;
        }
      }
      if (d_valori >= 20)
	printf ("inclinacion optima iteracion: %4d\n", incop);	  
    }
  if (d_valori == 10)
    printf ("inclinacion optima: %4d\n", incop);
  return incop;
}

void calculaAlineamientos (tglifo glifoColumnaP)
{
  int cgi[MAXLINS];
  int cgd[MAXLINS];
  int ngi, ngd, sumaCuads;
  int inclizq, inclder;
  int alinizq, alinder;
  tnodolglifo nodolGlifo;
  tglifo glifoLinea;
  n = 0;
  nodolGlifo = glifoColumnaP->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    if (nodolGlifo->aglifo->tipo == glifCompLin){
      if (alineamiento(&(als[n]), nodolGlifo->aglifo)) {
        if (n > 0)
          als[n].dfbss = als[n].bs - als[n-1].bs;
        else
          als[n].dfbss = 0 ;
        n ++ ;
	}
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
  if (d_valori >= 20)
     escribeAlineamientos (als, n);
  inclizq = glifoColumnaP->clmpInclizq = ajustesLinea (0);
  inclder = glifoColumnaP->clmpInclder = ajustesLinea (1);
  if (d_valori >= 20) {
    printf ("inclinacion optima izq.: %4d\n", inclizq);
    printf ("inclinacion optima der.: %4d\n", inclder);
    }
  unAjusteIzqDer (&ngi, cgi, &sumaCuads, inclizq, 0, v, n);
  unAjusteIzqDer (&ngd, cgd, &sumaCuads, inclizq, 1, v, n);
  alinizq = glifoColumnaP->clmpAlinizq = cgi[0] ;  /* elegirlo mejor <<< */
  alinder = glifoColumnaP->clmpAlinder = cgd[0] ;  /* elegirlo mejor <<< */
  nodolGlifo = glifoColumnaP->listaGlifos->primero;
  while (nodolGlifo !=  0L) {
    if (nodolGlifo->aglifo->tipo == glifCompLin){
      glifoLinea = nodolGlifo->aglifo;
      glifoLinea->linAlinizq =    glifoLinea->linLimizq - (glifoLinea->linBaseEncol * inclizq + K32) / K64 - alinizq ;
      glifoLinea->linAlinder = - (glifoLinea->linLimder - (glifoLinea->linBaseEncol * inclder + K32) / K64 - alinder) ;
      }
    nodolGlifo = nodolGlifo->siguiente;
    }
}

/*
void interlineado ();
*/

